SystemOrganization addCategory: #'MC2-Meta-Core-Abstract'!
SystemOrganization addCategory: #'MC2-Meta-Core-Domain'!
SystemOrganization addCategory: #'MC2-Meta-Core-Environment'!
SystemOrganization addCategory: #'MC2-Meta-Core-Slices'!

MDSliceInclusionHandler subclass: #MDMonticelloInclusionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Domain'!

!MDMonticelloInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 21:26'!
handleParent: anElement
	^ slice includesParentElement: anElement! !

!MDMonticelloInclusionHandler methodsFor: 'handling' stamp: 'jf 10/21/2009 17:19'!
handleSlice: anElement
	^ slice includesSliceElement: anElement! !

!MDUnionSlice class methodsFor: '*mc2-meta-core-converting' stamp: 'cwp 9/12/2009 12:31'!
elementClass
	^ MDUnionSliceElement! !

!MDExplicitSlice class methodsFor: '*mc2-meta-core-converting' stamp: 'cwp 9/12/2009 11:36'!
elementClass
	^ MDExplicitSliceElement! !

!MDSlice class methodsFor: '*mc2-meta-core-converting' stamp: 'cwp 9/12/2009 11:33'!
elementClass
	self subclassResponsibility! !

!MDSlice methodsFor: '*mc2-meta-core-dispatch' stamp: 'cwp 10/16/2009 22:24'!
includesParentElement: anElement
	^ false! !

!MDSlice methodsFor: '*mc2-meta-core-dispatch' stamp: 'cwp 10/16/2009 22:24'!
includesSliceElement: anElement
	^ false! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:07'!
handleBaselineSlice: anElement 
	^ self handleSlice: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:07'!
handleChangeSetSlice: anElement 
	^ self handleSlice: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:07'!
handleExplicitSlice: anElement 
	^ self handleSlice: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:10'!
handleMonticelloElement: aMethodElement 
	^ self handleElement: aMethodElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:23'!
handlePackageInfoSlice: anElement 
	^ self handleSlice: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:11'!
handleParent: anElement 
	^ self handleMonticelloElement: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:10'!
handleSlice: anElement 
	^ self handleMonticelloElement: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:13'!
handleSliceAssociation: anElement 
	^ self handleMonticelloElement: anElement! !

!MDElementHandler methodsFor: '*mc2-meta-core-handling' stamp: 'jf 10/21/2009 17:07'!
handleUnionSlice: anElement 
	^ self handleSlice: anElement! !

MDElementHandler subclass: #MDMonticelloAdaptionHandler
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Domain'!

!MDMonticelloAdaptionHandler class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:05'!
environment: anEnvironment
	^ self basicNew
		initializeWithEnvironment: anEnvironment;
		yourself! !

!MDMonticelloAdaptionHandler class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:18'!
new
	self shouldNotImplement! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'jf 1/31/2010 15:56'!
handleChangeSetSlice: anElement
	^ MDChangeSetSliceAdaptor 
		forElement: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/17/2009 09:37'!
handleElement: anObject
	"There's no reasonable default behavior here."
	
	self error: 'No adaptor available for ', anObject printString.! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'jf 1/31/2010 15:56'!
handleExplicitSlice: anElement
	^ MDExplicitSliceAdaptor 
		forElement: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'jf 1/31/2010 15:57'!
handlePackageInfoSlice: anElement
	^ MDPackageInfoSliceAdaptor 
		forElement: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'handling' stamp: 'jf 1/31/2010 15:57'!
handleUnionSlice: anElement
	^  MDUnionSliceAdaptor 
		forElement: anElement 
		inEnvironment: environment! !

!MDMonticelloAdaptionHandler methodsFor: 'initialize-release' stamp: 'cwp 10/16/2009 23:00'!
initializeWithEnvironment: anEnvironment
	self initialize.
	environment := anEnvironment! !

MDElement subclass: #MDMonticelloElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Abstract'!

!MDMonticelloElement methodsFor: 'adapting' stamp: 'cwp 7/20/2010 10:47'!
domain
	^ #monticello! !

MDMonticelloElement subclass: #MDSliceElement
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Slices'!

MDSliceElement subclass: #MDExplicitSliceElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Slices'!

!MDExplicitSliceElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:33'!
handleWith: anObject
	^ anObject handleExplicitSlice: self! !

!MDSliceElement class methodsFor: 'as yet unclassified' stamp: 'cwp 2/17/2010 21:53'!
for: aSlice
	^ self id: aSlice id! !

!MDSliceElement class methodsFor: 'as yet unclassified' stamp: 'cwp 2/17/2010 21:48'!
id: aHashstamp
	^ self basicNew initializeWithId: aHashstamp! !

!MDSliceElement methodsFor: 'comparing' stamp: 'cwp 2/17/2010 21:42'!
= other 
	^ self species = other species 
		and: [id = other id] ! !

!MDSliceElement methodsFor: 'printing' stamp: 'cwp 2/17/2010 21:43'!
displayClassName
	^ self className allButFirst: 2! !

!MDSliceElement methodsFor: 'comparing' stamp: 'cwp 2/17/2010 21:43'!
hash
	^ ByteArray 
		hashBytes: id 
		startingWith: self species hash! !

!MDSliceElement methodsFor: 'accessing' stamp: 'cwp 2/17/2010 21:44'!
id
	^ id! !

!MDSliceElement methodsFor: 'initialize-release' stamp: 'cwp 2/17/2010 21:44'!
initializeWithId: aHashstamp
	self initialize.
	id := aHashstamp! !

MDSliceElement subclass: #MDUnionSliceElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Slices'!

!MDUnionSliceElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:34'!
handleWith: anObject
	^ anObject handleUnionSlice: self! !

MDFacade subclass: #MDMonticelloFacade
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Domain'!

MDMonticelloFacade class
	instanceVariableNames: 'default'!

MDMonticelloFacade class
	instanceVariableNames: 'default'!

!MDMonticelloFacade class methodsFor: 'defaults' stamp: 'jf 1/8/2010 15:05'!
default
	^ default ifNil: [default := self new]! !

!MDMonticelloFacade class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:07'!
environment: anEnvironment
	^ self basicNew
		initializeWithEnvironment: anEnvironment;
		yourself! !

!MDMonticelloFacade class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:07'!
new
	^ self environment: MDEnvironment default! !

!MDMonticelloFacade class methodsFor: 'accessing' stamp: 'cwp 6/15/2008 20:41'!
type
	^ #monticello! !

!MDMonticelloFacade methodsFor: 'public' stamp: 'cwp 10/16/2009 23:00'!
adapt: anElement
	^ anElement handleWith: (MDMonticelloAdaptionHandler environment: environment)! !

!MDMonticelloFacade methodsFor: 'initializing' stamp: 'jf 1/8/2010 15:03'!
initializeWithEnvironment: anEnvironment
	self initialize.
	environment := anEnvironment! !

!MDMonticelloFacade methodsFor: 'testing' stamp: 'cwp 5/26/2008 22:04'!
name
	^ #monticello! !

MDAdaptor subclass: #MDMonticelloAdaptor
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Abstract'!

!MDMonticelloAdaptor class methodsFor: 'instance creation' stamp: 'jf 1/19/2010 22:57'!
forElement: anElement
	self shouldNotImplement! !

!MDMonticelloAdaptor class methodsFor: 'instance creation' stamp: 'jf 1/31/2010 15:56'!
forElement: anElement inEnvironment: anEnvironment
	^ self basicNew
		initializeWithElement: anElement environment: anEnvironment;
		yourself! !

!MDMonticelloAdaptor methodsFor: 'accessing' stamp: 'jf 9/26/2009 01:54'!
environment
	^ environment! !

!MDMonticelloAdaptor methodsFor: 'initialize-release' stamp: 'jf 1/19/2010 22:41'!
initializeWithElement: anElement environment: anEnvironment
	self initializeWithElement: anElement.
	environment := anEnvironment! !

MDMonticelloAdaptor subclass: #MDSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Slices'!

MDSliceAdaptor subclass: #MDExplicitSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Slices'!

!MDExplicitSliceAdaptor methodsFor: 'private' stamp: 'cwp 1/18/2010 22:04'!
createSlice: properties
	^ MDExplicitSlice
		id: element id
		name: properties name
		elements: properties elements! !

!MDExplicitSliceAdaptor methodsFor: 'private' stamp: 'jf 10/21/2009 15:08'!
update: properties fromSlice: aSlice
	super update: properties fromSlice: aSlice.
	properties elements: aSlice elements! !

!MDSliceAdaptor methodsFor: 'private' stamp: 'jf 10/16/2009 22:52'!
createSlice: properties
	self subclassResponsibility! !

!MDSliceAdaptor methodsFor: 'testing' stamp: 'jf 9/6/2009 13:13'!
isLoadable: properties
	^ true! !

!MDSliceAdaptor methodsFor: 'testing' stamp: 'jf 1/31/2010 12:20'!
isPresent
	^ self environment includesSliceId: element id! !

!MDSliceAdaptor methodsFor: 'testing' stamp: 'jf 10/21/2009 14:58'!
isUpToDate: properties
	^ self properties = properties! !

!MDSliceAdaptor methodsFor: 'public' stamp: 'jf 1/31/2010 12:20'!
load: properties
	| slice |
	slice := self sliceIfAbsent: [self createSlice: properties].
	self environment addSlice: slice.! !

!MDSliceAdaptor methodsFor: 'private' stamp: 'jf 10/21/2009 14:58'!
properties
	^ self update: MDPropertyDictionary new! !

!MDSliceAdaptor methodsFor: 'public' stamp: 'jf 1/31/2010 12:20'!
remove
	| slice |
	slice := self sliceIfAbsent: [^ self].
	self environment removeSliceId: slice id! !

!MDSliceAdaptor methodsFor: 'private' stamp: 'jf 1/31/2010 12:20'!
sliceIfAbsent: aBlock
	^ self environment slices 
		detect: [:ea | ea id = element id] 
		ifNone: aBlock! !

!MDSliceAdaptor methodsFor: 'public' stamp: 'jf 10/21/2009 15:05'!
update: properties
	| slice |
	slice := self sliceIfAbsent: [^ properties].
	self update: properties fromSlice: slice.
	^ properties! !

!MDSliceAdaptor methodsFor: 'private' stamp: 'jf 10/21/2009 15:14'!
update: properties fromSlice: aSlice
	properties name: aSlice name! !

MDSliceAdaptor subclass: #MDUnionSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Slices'!

!MDUnionSliceAdaptor methodsFor: 'private' stamp: 'cwp 1/18/2010 22:20'!
createSlice: properties
	^ MDUnionSlice
		id: element id
		name: properties name
		slices: (properties sliceIds collect: [:ea | self environment sliceWithId: ea])! !

!MDUnionSliceAdaptor methodsFor: 'testing' stamp: 'jf 10/17/2009 00:46'!
isLoadable: properties
	^ (super isLoadable: properties) and: [
		properties sliceIds allSatisfy: [:each |
			self environment includesSliceId: each] ]! !

!MDUnionSliceAdaptor methodsFor: 'private' stamp: 'jf 10/21/2009 15:08'!
update: properties fromSlice: aSlice
	super	update: properties fromSlice: aSlice.
	properties sliceIds: (aSlice slices collect: [:ea | ea id])! !

MDObject subclass: #MDRegistry
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Core-Environment'!

!MDRegistry class methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2008 18:53'!
new
	^ self basicNew initialize! !

!MDRegistry methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 22:23'!
commit! !

!MDRegistry methodsFor: 'testing' stamp: 'cwp 11/9/2007 21:42'!
includesId: id
	^ objects includesKey: id! !

!MDRegistry methodsFor: 'initialization' stamp: 'jf 11/8/2009 17:08'!
initialize
	super initialize.
	objects := Dictionary new.
	! !

!MDRegistry methodsFor: 'accessing' stamp: 'cwp 6/14/2008 13:32'!
objectWithId: id
	^ objects at: id ifAbsent: [nil]! !

!MDRegistry methodsFor: 'accessing' stamp: 'cwp 8/14/2009 18:13'!
objectWithId: id ifAbsent: aBlock
	^ objects at: id ifAbsent: aBlock! !

!MDRegistry methodsFor: 'accessing' stamp: 'cwp 11/9/2007 22:00'!
objectWithId: id satisfies: aBlock
	^ aBlock value: (objects at: id ifAbsent: [^ false])! !

!MDRegistry methodsFor: 'accessing' stamp: 'cwp 11/9/2007 21:29'!
objects
	^ objects values! !

!MDRegistry methodsFor: 'adding' stamp: 'jf 9/26/2009 01:46'!
register: anObject
	^ objects at: anObject id put: anObject! !

!MDRegistry methodsFor: 'removing' stamp: 'cwp 11/19/2007 23:36'!
unregister: anObject
	^ self unregisterId: anObject id! !

!MDRegistry methodsFor: 'removing' stamp: 'jf 9/8/2009 23:36'!
unregister: anObject ifAbsent: absentBlock
	^ self unregisterId: anObject id ifAbsent: absentBlock! !

!MDRegistry methodsFor: 'removing' stamp: 'jf 9/8/2009 23:34'!
unregisterId: id
	^ self unregisterId: id ifAbsent: [nil]! !

!MDRegistry methodsFor: 'removing' stamp: 'jf 9/8/2009 23:34'!
unregisterId: id ifAbsent: absentBlock
	^ objects removeKey: id ifAbsent: absentBlock! !
